﻿; Logbuchprogramm
; DK1IO 04/11

EnableExplicit

Import ""
  PB_Gadget_SendGadgetCommand(hWnd, EventType)
EndImport

XIncludeFile "LogDeclares.pbi"
XIncludeFile "LogConstants.pbi"
XIncludeFile "LogGlobals.pbi"
XIncludeFile "LogWndOp.pbi"
XIncludeFile "LogMenu.pbi"
XIncludeFile "LogPSKProc.pbi"
XIncludeFile "LogGenProc.pbi"
XIncludeFile "LogCBProc.pbi"

SetWindowCallback(@WindowCallback())

DatabaseQuery(#DB, "SELECT * FROM Tab_Start")
FirstDatabaseRow(#DB)
sEigRufz = GetDBString(#DB, "EigRufz")
EigRufz$ = sEigRufz
sPx = GetDBString(#DB, "Px")
If Len(sPx)
  sEigRufz = sPx + "/" + sEigRufz
EndIf
sMP = GetDBString(#DB, "MP")
If Len(sMP)
  sEigRufz + "/" + sMP
EndIf
sECOTA = GetDBString(#DB, "ECOTA")
sEIOTA = GetDBString(#DB, "EIOTA")
sESOTA = GetDBString(#DB, "ESOTA")
sEETPA = GetDBString(#DB, "EETPA")
sELoc = GetDBString(#DB, "ELoc")
sEQTH = GetDBString(#DB, "EQTH")
sLH = GetDBString(#DB, "LH")
sAnt = GetDBString(#DB, "Ant")
SetGadgetData(#Txt_Band, GetDBLong(#DB, "Band"))
FinishDatabaseQuery(#DB)

GetSystemTime_(yST)
Define iDat = Date()
iTimeOffset = yST\wHour - Hour(iDat)
SetGadgetText(#Txt_Datum, FormatDate("%dd.%mm.%yyyy", iDat))
If OpenFile(9, "C:\Users\RL\\Documents\TXT\PSKLog " + Str(yST\wYear) + "-" + RSet(Str(yST\wMonth), 2, "0") + ".txt")
  Delay(10)
  FileSeek(9, Lof(9))
Else
  MessageRequester("Fehler", "Datei 9 nicht geöffnet")
EndIf
WriteDTG("Start")
AddWindowTimer(#Wnd_Op, #Tmr_DTG, 60000)
AddWindowTimer(#Wnd_Op, #Tmr_Uhr, 1000)

SetGadgetData(#Txt_Power, 6)

hCOM_FT991 = OpenSerialPort(#COM_FT991, "COM3", 38400, #PB_SerialPort_NoParity, 8, 1, #PB_SerialPort_NoHandshake, 64, 64)
If Not hCOM_FT991
  MessageRequester("Fehler", "Die serielle Verbindung zum FT-991 (COM3) konnte nicht geöffnet werden")
  End
EndIf

SetWindow()

Define.b bTemp
Define i, ii, iii, int1, WindowNr, GadgetNr, EventNr, MenuNr, TypeNr
Define.s sCont, sDipl, sRecSce, sSel1, sSel2, str1

Repeat
  EventNr  = WaitWindowEvent()
  WindowNr = EventWindow()
  TypeNr   = EventType()
  GadgetNr = EventGadget()
  MenuNr   = EventMenu()
  Select WindowNr
    Case #Wnd_Op
      Select EventNr 
        Case #PB_Event_CloseWindow
          PSKCore_StopSoundCard()
          WindowClose()
        Case #PB_Event_Timer
          Select EventTimer()
            Case #Tmr_DTG
              WriteDTG("")
            Case #Tmr_Uhr
              GetSystemTime_(yST)
              SetGadgetText(#Txt_Zeit, RSet(Str(yST\wHour), 2, "0") + ":" + RSet(Str(yST\wMinute), 2, "0") + ":" + RSet(Str(yST\wSecond), 2, "0"))
              ;While CountGadgetItems(#Edt_PSKRXTxt) > 50
              ;  RemoveGadgetItem(#Edt_PSKRXTxt, 0)
              ;Wend
            Case #Tmr_Log
              SetGadgetColor(#Btn_Log, #PB_Gadget_FrontColor, #DBlue)
              RemoveWindowTimer(#Wnd_Op, #Tmr_Log)
          EndSelect
        Case #WM_RBUTTONUP
          GetCursorPos_(pnt1)
          For i = 0 To 3
            GetWindowRect_(GadgetID(R_ClkBtns(i)), rct1)
            If PtInRect_(rct1, PeekQ(pnt1))
              GadgetNr = R_ClkBtns(i)
              Break
            Else
              GadgetNr = #Btn_Dummy            
            EndIf
          Next
          Select GadgetNr
            Case #Btn_Begr
              SetGadgetText(#Str_RSTs, "599")
              SpTxtAusgPSK(GadgetNr, " s")
            Case #Btn_CQ
              SpTxtAusgPSK(GadgetNr, " DX")
            Case #Btn_FreqDn
              WriteSerialPortString(#COM_FT991, "RT1;")
              WriteSerialPortString(#COM_FT991, "RD0010;")
            Case #Btn_FreqUp
              WriteSerialPortString(#COM_FT991, "RT1;")
              WriteSerialPortString(#COM_FT991, "RU0010;")
          EndSelect
        Case #PB_Event_Gadget
          Select GadgetNr
            Case #Btn_Begr, #Btn_Bye, #Btn_Rig, #Btn_TnxBye, #Btn_TnxInfo, #Btn_Vorst
              If GetGadgetColor(#Btn_TX, #PB_Gadget_BackColor) & GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #BtnCol
                SpTxtAusgPSK(GadgetNr, " " + GetGadgetText(#Btn_Sprache))
              EndIf
            Case #Btn_Anr, #Btn_BTU, #Btn_Copy, #Btn_CQ, #Btn_de, #Btn_de2, #Btn_DK1IO, #Btn_Fin, #Btn_QRZ, #Btn_SK
              If GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #BtnCol
                SpTxtAusgPSK(GadgetNr, "")
              EndIf
            Case #Btn_FreqDn
              str1 = Str(Val(sFreq) - 1000)
              sFreq = RSet(str1, 9, "0")
              WriteSerialPortString(#COM_FT991, "FA" + sFreq + ";")
              int1 = Val(sFreq) + iRXFreq - 1500
              str1 = RSet(Str(int1), 9, "0")
              WriteSerialPortString(#COM_FT991, "FB" + sFreq + ";")
            Case #Btn_FreqUp
              str1 = Str(Val(sFreq) + 1000)
              sFreq = RSet(str1, 9, "0")
              WriteSerialPortString(#COM_FT991, "FA" + sFreq + ";")
              int1 = Val(sFreq) + iRXFreq - 1500
              str1 = RSet(Str(int1), 9, "0")
              WriteSerialPortString(#COM_FT991, "FB" + sFreq + ";")
            Case #Btn_Log
              Dim sRufz.s(1)
              sRufz(0) = GetGadgetText(#Str_Rufzeichen)
              sRufz(1) = GetGadgetText(#Str_AndRufz)
              If FindString(sRufz(0), "DK1IO")
                  MessageRequester("Fehler", "QSO mit DK1IO?")
              Else
                If sRufz(0) <> ""
                  SetGadgetColor(#Btn_Log, #PB_Gadget_FrontColor, #Red)
                  AddWindowTimer(#Wnd_Op, #Tmr_Log, 750)
                  If sRufz(1) <> "" : iii = 1 : Else : iii = 0 : EndIf
                  Define sDat.s, sTim.s, iDat, iTim
                  sMode = GetGadgetText(#Txt_Mode)
                  If Val(sPwr) > 50 : sPwr = "50" : EndIf
                  GetSystemTime_(@yST)
                  iDat = Date()
                  iTim = Val(FormatDate("%hh", iDat))
                  If iTim < yST\wHour : iTim + 24 : EndIf
                  iDat = AddDate(iDat, #PB_Date_Hour, yST\wHour - iTim)
                  sDat = FormatDate("%yyyy-%mm-%dd", iDat)
                  sTim = FormatDate("%hh%ii", iDat)
                  If bPapLogEing
                    sTim = GetGadgetText(#Str_UTC)
                  EndIf
                  DatabaseQuery(#DB, "SELECT Kz FROM Tab_EigRufz WHERE Rufz = '" + EigRufz$ + "'")
                  FirstDatabaseRow(#DB)
                  Define.s sKz = GetDatabaseString(#DB, 0)
                  FinishDatabaseQuery(#DB)
                  For i = 0 To iii
                    str1 = "INSERT INTO Tab_Log (Datum, UTC, Rufzeichen, EigRufz, Band, Mode, Power, RSTs, RSTr, Name, QTH, Loc,"
                    str1 + "ELoc, IOTA, EIOTA, SOTA, ECOTA, ESOTA, EETPA, ITUZ, Px, MP, Bemerkungen, QSLe, QSLa, DXCC, QSLPrt, Comment,"
                    str1 + " eQSL) VALUES('" + sDat + "','" + sTim + "','" + sRufz(i) + "','" + sKz + "',"
                    str1 + Str(GetGadgetData(#Txt_Band)) + ",'" + GetGadgetText(#Txt_Mode) + "',"
                    str1 + sPwr + ",'" + GetGadgetText(#Str_RSTs) + "','" + GetGadgetText(#Str_RSTr)
                    str1 + "','" + GetGadgetText(#Str_Name) + "','" + GetGadgetText(#Str_QTH) + "','"
                    str1 + GetGadgetText(#Str_Locator) + "','" + sELoc + "','"
                    str1 + GetGadgetText(#Str_IOTA) + "','" + sEIOTA + "','" + sSOTA + "','" + sECOTA + "','" + sESOTA + "','" + sEETPA + "',"
                    str1 + Str(0) + ",'" + sPx + "','" + sMP + "','" + GetGadgetText(#Str_Bemerkungen) + "'," + Str(0) + ","
                    str1 + Str(GetGadgetData(#Btn_QSLa)) + "," + Str(iDXCC) + ","
                    str1 + Str(GetGadgetData(#Btn_QSLa) & bQSLPrt) + ",'" + GetGadgetText(#Str_Comment) + "'," + Str(0) + ")"
                    DatabaseUpdate(#DB, str1)
                    If DatabaseError()
                      MessageRequester("Fehler", DatabaseError())
                    EndIf
                    SetGadgetText(#Txt_QSONr, Str(Val(GetGadgetText(#Txt_QSONr)) + 1))
                    WriteDTG("Logged: ")
                  Next
                  FinishDatabaseQuery(#DB)
                  Reset()
                  If GetGadgetData(#Txt_LfdNr)
                    SetGadgetData(#Str_LfdNr, GetGadgetData(#Str_LfdNr) + 1)
                    SetGadgetText(#Str_LfdNr, RSet(Str(GetGadgetData(#Str_LfdNr)), 3, "0"))
                  EndIf
                EndIf
                SetGadgetData(#Cnt_Log, #Str_Rufzeichen)
              EndIf
            Case #Btn_PwrDn
              SetPower(-1)
            Case #Btn_PwrUp
              SetPower(1)
            Case #Btn_QSLa
              Select GetGadgetColor(#Btn_QSLa, #PB_Gadget_FrontColor)
                Case #DBlue
                  SetGadgetColor(#Btn_QSLa, #PB_Gadget_FrontColor, #Red) : SetGadgetData(#Btn_QSLa, #True)
                Case #Red
                  SetGadgetColor(#Btn_QSLa, #PB_Gadget_FrontColor, #DBlue) : SetGadgetData(#Btn_QSLa, #False)
              EndSelect
            Case #Btn_RSTsDn
              int1 = Val(GetGadgetText(#Str_RSTs)) - 10
              If int1 < 539 : int1 = 539 : EndIf
              SetGadgetText(#Str_RSTs, Str(int1))
            Case #Btn_RSTsUp
              ;int1 = Val(GetGadgetText(#Str_RSTs)) + 10
              ;If int1 > 599 : int1 = 599 : EndIf
              SetGadgetText(#Str_RSTs, "599")
            Case #Btn_RX
              If GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #BtnCol
                StopTX(#Btn_TX)
              EndIf
            Case #Btn_Sprache
              If GetGadgetText(#Btn_Sprache) = "E"
                SetGadgetText(#Btn_Sprache, "D")
              Else
                SetGadgetText(#Btn_Sprache, "E")
              EndIf
            Case #Btn_Tune
              If GetGadgetColor(#Btn_TX, #PB_Gadget_BackColor) = #BtnCol
                If GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #Red
                  SetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor, #BtnCol)
                  WriteSerialPortString(#COM_FT991, "TX0;")
                  WriteSerialPortString(#COM_FT991, Pwr$)
                  Delay(10)
                  WriteSerialPortString(#COM_FT991, "MD0C;")
                  WriteSerialPortString(#COM_FT991, "SV;")
                   WriteSerialPortString(#COM_FT991, "MD0C;")
                Else
                  SetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor, #Red)
                  PurgeComm_(SerialPortID(#COM_FT991), #PURGE_RXCLEAR)
                  
                  WriteSerialPortString(#COM_FT991, "PC;")
                  Delay(50)
                  i = AvailableSerialPortInput(#COM_FT991)
                  ReadSerialPortData(#COM_FT991, *CommRXBuf, i)
                  Pwr$ = PeekS(*CommRxBuf, i, #PB_Ascii)
                  WriteSerialPortString(#COM_FT991, "PC016;")
                  Delay(10)
                  WriteSerialPortString(#COM_FT991, "MD03;")
                  WriteSerialPortString(#COM_FT991, "SV;")
                  WriteSerialPortString(#COM_FT991, "TX1;")
                EndIf
              EndIf
            Case #Btn_TX
              If GetGadgetColor(#Btn_Tune, #PB_Gadget_BackColor) = #BtnCol
                SetGadgCol(#Btn_TX, #DBlue, #Red)
                HideGadget(#Edt_PSKRXTxt, 1) : HideGadget(#Edt_PSKTXTxt, 0)
                WriteSerialPortString(#COM_FT991, "TX1;")
                PSKCore_StartTX(iPSKMode)
                SetGadgetData(#Cnt_Log, GetActiveGadget())
                SetActiveGadget(#Edt_PSKTXTxt)
                bPSKTX = #True
              EndIf
            Case #Edt_PSKRXTxt
              If Not GetActiveGadget() = #Edt_PSKTXTxt
                ;SetActiveGadget(GetGadgetData(#Cnt_Log))
              EndIf
            Case #Img_Wf
              Define mX = WindowMouseX(0), mY = WindowMouseY(0), iNewFreq
              If mX > 10 And mX < 652 And mY > 540 And mY < 700
                Select TypeNr
                  Case #PB_EventType_LeftClick
                    iLineRX = mX - 11
                    iRXFreq = Int((mX + 53) * 3.90625)
                    PSKCore_SetRXFrequency(iRXFreq, 10, 0)
                    int1 = Val(sFreq) + iRXFreq - 1500
                    str1 = RSet(Str(int1), 9, "0")
                    WriteSerialPortString(#COM_FT991, "FB" + str1 + ";")
                EndSelect
              EndIf
              SetGadgetText(#Txt_IMD, "IMD: ")
            Case #LI_QSOB4
              Select TypeNr
                Case #PB_EventType_LeftClick
                  Define rTemp.Rect, str2.s, str3.s, str4.s
                  str1 = GetGadgetItemText(GadgetNr, iRow, iCol)
                  str2 = GetGadgetItemText(GadgetNr, -1, iCol)
                  str3 = GetGadgetItemText(GadgetNr, iRow, 0)
                  Select str2
                    Case "Neu", "QSLe", "QSLa", "DL0NRU", "QSLPrt"
                      If str1 = Chr($A3) : str1 = Chr($53) : str4 = "-1" : Else : str1 = Chr($A3) : str4 = "0" : EndIf
                      SetGadgetItemText(GadgetNr, iRow, str1, iCol)
                      sCmd = "UPDATE Tab_Log SET '" + str2 +  "' = " + str4 + " WHERE ROWID = " + str3
                      DatabaseUpdate(#DB, sCmd)
                    Default
                      rTemp\top = iCol: rTemp\left = #LVIR_BOUNDS
                      SendMessage_(GadgetID(GadgetNr), #LVM_FIRST + 56, iRow, @rTemp)
                      ResizeGadget(#Str_Update0, GadgetX(GetActiveGadget()) + rTemp\left + 3, rTemp\Top + GadgetY(#LI_QSOB4) + 1, rTemp\right - rTemp\left, rTemp\bottom - rTemp\top + 1)
                      SetGadgetText(#Str_Update0, str1)
                      HideGadget(#Str_Update0, 0)
                  EndSelect
              EndSelect
            Case #Str_AndRufz
              SetGadgetData(#Cnt_Log, GadgetNr)
              If TypeNr = #PB_EventType_LostFocus
                str1 = GetGadgetText(#Str_AndRufz)
                If str1 > "" : QSOB4(str1) : EndIf
              EndIf
            Case #Str_IOTA
              SetGadgetData(#Cnt_Log, GadgetNr)
              str1 = GetGadgetText(GadgetNr)
              If Like(str1, "@@-###", #True)
                IOTA(str1)
              EndIf
            Case #Str_LfdNr
              SetGadgetData(#Cnt_Log, GadgetNr)
              If GetGadgetData(#Txt_LfdNr)
                SetGadgetData(#Str_LfdNr, Val(GetGadgetText(#Str_LfdNr)))
                str1 = "UPDATE Tab_Start SET LfdNr = " + Str(GetGadgetData(#Str_LfdNr) -1)
                DatabaseUpdate(#DB, str1)
              EndIf
            Case #Str_Locator
              SetGadgetData(#Cnt_Log, GadgetNr)
              Select TypeNr
                Case #PB_EventType_Change
                  str1 = GetGadgetText(#Str_Locator)
                  If Like(str1, "@@##@@", #True)
                    EntfBer()
                    str2 = GetGadgetText(#Str_Rufzeichen)
                    If FindString(str2, "/", 1) And Not (Right(str2, 3) = "QRP" Or Right(str2, 3) = "/MM")
                      sRecSce = "SELECT SUBSTR(Loc, 1, 4) AS Locator FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Rufzeichen LIKE '%/%' AND Rufzeichen NOT LIKE '%/QRP' AND Rufzeichen NOT LIKE '%/MM' AND Locator = '" + Left(str1, 4) + "'"
                      If DatabaseQuery(#DB, sRecSce)
                        If FirstDatabaseRow(#DB)
                          SetGadgCol(#Txt_Locator, #DBlue, GetWindowColor(#Wnd_Op))
                        Else
                          SetGadgCol(#Txt_Locator, #Red, GetWindowColor(#Wnd_Op))
                        EndIf
                      Else
                        DBError()
                      EndIf
                    EndIf
                  EndIf
                  If Len(str1) = 2
                    sRecSce = "SELECT Band, Mode, Loc FROM Tab_Log WHERE Band = " + Str(GetGadgetData(#Txt_Band)) + " AND Mode = '" + GetGadgetText(#Txt_Mode) + "' AND Loc = '" + GetGadgetText(#Str_Locator) + "' GROUP BY Loc, Band, Mode"
                    If DatabaseQuery(#DB, sRecSce)
                      If FirstDatabaseRow(#DB)
                        SetGadgCol(#Str_Locator, #DBlue, #LogCol)
                      Else
                        SetGadgCol(#Str_Locator, #DGreen, #LogCol)
                      EndIf 
                    Else
                      DBError()
                    EndIf 
                    FinishDatabaseQuery(#DB)
                  EndIf
              EndSelect
            Case #Str_Name
              SetGadgetData(#Cnt_Log, GadgetNr)
              Select TypeNr
                Case #PB_EventType_LostFocus
                  str1 = GetGadgetText(GadgetNr)
                  SetGadgetText(GadgetNr, UCase(Left(str1, 1)) + Right(str1, Len(str1) - 1))
              EndSelect
            Case #Str_QTH
              SetGadgetData(#Cnt_Log, GadgetNr)
              str1 = GetGadgetText(GadgetNr)
              Select TypeNr
                Case #PB_EventType_Focus
                  SetGadgCol(GadgetNr, #DBlue, #LogCol)
                Case #PB_EventType_LostFocus
                  If Left(str1, 3) = "nr "
                    SetGadgetText(GadgetNr, "nr " + UCase(Mid(str1, 4, 1)) + Right(str1, Len(str1) - 4))
                  Else
                    SetGadgetText(GadgetNr, UCase(Left(str1, 1)) + Right(str1, Len(str1) - 1))
                  EndIf
              EndSelect
            Case #Str_RSTr, #Str_RSTs
              SetGadgetData(#Cnt_Log, GadgetNr)
              Select TypeNr
                Case #PB_EventType_Change
                  If GadgetNr = #Str_RSTr : int1 = #Str_Name : Else : int1 = #Str_RSTr : EndIf
                  If Len(GetGadgetText(GadgetNr)) = 3
                  EndIf
              EndSelect
            Case #Str_Rufzeichen
              SetGadgetData(#Cnt_Log, GadgetNr)
              Select TypeNr
                Case #PB_EventType_Change
                  SetGadgCol(#Txt_Rufzeichen, #DBlue, #CntCol) : iNumQSOB4 = 0
                Case #PB_EventType_Focus
                  SetGadgCol(GadgetNr, #DBlue, #LogCol)
                Case #PB_EventType_LostFocus
                  RufzGadgLostFocus(GadgetNr)
              EndSelect
            Case #Str_Update0
              Select TypeNr
                Case #PB_EventType_Change
                  SetGadgetData(GadgetNr, #True)
                Case #PB_EventType_LostFocus
                  If GetGadgetData(GadgetNr)
                    str1 = GetGadgetItemText(#LI_QSOB4, -1, iCol)
                    str2 = GetGadgetText(GadgetNr)
                    str3 = GetGadgetItemText(#LI_QSOB4, iRow, 0)
                    sCmd = "UPDATE Tab_Log SET '" + str1 + "' = '" + str2 + "' WHERE ROWID = " + str3
                    DatabaseUpdate(#DB, sCmd)
                    If str4 = "SWL"
                      sCmd = "UPDATE Tab_Log SET QSLPrt = -1, QSLa = -1 WHERE ROWID = " + str3
                      DatabaseUpdate(#DB, sCmd)
                    EndIf
                    SetGadgetItemText(#LI_QSOB4, iRow, str2, iCol)
                    SetGadgetData(GadgetNr, #False)
                  EndIf
              EndSelect
            Case #Str_WXD To #Str_Temp
              SetGadgetData(#Cnt_Log, GadgetNr)
              If TypeNr = #PB_EventType_Focus
                int1 = GetGadgetData(#Cnt_Log)
                SetGadgetData(GadgetNr, int1)
                SetGadgetData(#Cnt_Log, GadgetNr)
                SetGadgetText(GadgetNr, "")
              ElseIf TypeNr = #PB_EventType_LostFocus
                SetGadgetData(#Cnt_Log, int1)
              EndIf
            Case #Txt_AndRufz
              SetGadgetText(#Str_AndRufz, "")
            Case #Txt_Bemerkungen
              Select GetGadgetText(GadgetNr)
                Case "Bemerkungen"
                  SetGadgetText(GadgetNr, "Comment")
                  HideGadget(#Str_Bemerkungen, 1) : HideGadget(#Str_Comment, 0)
                  SetActiveGadget(#Str_Comment)
                Case "Comment"
                  SetGadgetText(GadgetNr, "Bemerkungen")
                  HideGadget(#Str_Comment, 1) : HideGadget(#Str_Bemerkungen, 0)
                  SetActiveGadget(#Str_Bemerkungen)
              EndSelect
            Case #Txt_Locator
              SetGadgetText(#Str_Locator, "")
              SetGadgCol(#Str_Locator, #DBlue, #LogCol)
              SetGadgetText(#Txt_Entf, "") : SetGadgetText(#Txt_Ri, "")
            Case #Txt_Name
              SetGadgetText(#Str_Name, "") : iYL = #False
              SetGadgCol(#Str_Name, #DBlue, #LogCol)
            Case #Txt_QTH
              SetGadgetText(#Str_QTH, "")
            Case #Txt_Rufzeichen
              SetGadgetText(#Str_Rufzeichen, "")
              SetGadgCol(GadgetNr, #DBlue, GetWindowColor(#Wnd_Op))
              SetGadgCol(#Str_Rufzeichen, #DBlue, #LogCol)
          EndSelect
        Case #PB_Event_Menu
          str1 = GetMenuItemText(0, MenuNr)
          Select MenuNr
            Case 101                           ; Löschen
              Reset()
            Case 120                           ; Tab
              ;SetActiveGadget(GetGadgetData(GetActiveGadget()))
              ;SetGadgetData(#Cnt_Log, GetActiveGadget())
            Case 140
              bTXStop = #True
            Case 910                                        ; C -> E
              Define.s sTabNam = InputRequester("Datenbanktabelle kopieren", "Tabellenname:", "Tab_Log")
              If sTabNam > ""
                DatabaseUpdate(#DB, "ATTACH 'E:\Log DK1IO.db3' AS A")
                DatabaseUpdate(#DB, "DROP TABLE A." + sTabNam)
                DatabaseUpdate(#DB, "CREATE TABLE A." + sTabNam + " AS SELECT * FROM " + sTabNam)
                DatabaseUpdate(#DB, "VACUUM A")
                DatabaseUpdate(#DB, "DETACH A")
                If DatabaseError() = ""
                  MessageRequester("OK", "Der Tabellentransfer war erfolgreich")
                Else
                  MessageRequester("Fehler", DatabaseError())
                EndIf
              EndIf
            Case 920                                        ; E -> C
              Define.s sTabNam = InputRequester("Datenbanktabelle kopieren", "Tabellenname:", "Tab_Log")
              If sTabNam > ""
                DatabaseUpdate(#DB, "DROP TABLE " + sTabNam)
                DatabaseUpdate(#DB, "ATTACH 'E:\Log DK1IO.db3' AS A")
                DatabaseUpdate(#DB, "CREATE TABLE " + sTabNam + " AS SELECT * FROM A." + sTabNam)
                DatabaseUpdate(#DB, "DETACH A")
                DatabaseUpdate(#DB, "VACUUM")
                If DatabaseError() = ""
                  MessageRequester("OK", "Der Tabellentransfer war erfolgreich")
                Else
                  MessageRequester("Fehler", DatabaseError())
                EndIf
              EndIf
            Case 950
              InitNetwork()
              If ReceiveHTTPFile("http://epc-mc.de/download/epcdlde/epcepcno.txt", "C:\Users\DK1IO\Downloads\EPC_Members_List.txt")
                MessageRequester("OK", "Der Dateidownload war erfolgreich!")
                DatabaseUpdate(#DB, "DELETE FROM Tab_EPC_Members")
                If OpenFile(0, "C:\Users\DK1IO\Downloads\EPC_Members_List.txt")
                  Define int2 : Define str5.s
                  DatabaseUpdate(#DB, "BEGIN TRANSACTION")
                  Repeat
                    str1 = ReadString(0)
                    str1 = RemoveString(str1, Chr(34))
                    int1 = FindString(str1, ",", 1)
                    str2 = Left(str1, int1)
                    str1 = RemoveString(str1, str2)
                    str3 = RemoveString(str2, ",")
                    int1 = FindString(str1, ",", 1)
                    str2 = Left(str1, int1)
                    str1 = RemoveString(str1, str2)
                    str4 = RemoveString(str2, ",")
                    int1 = FindString(str1, ",", 1)
                    str2 = Left(str1, int1)
                    str1 = RemoveString(str1, str2)
                    str5 = RemoveString(str2, ",")
                    str5 = RemoveString(str5, "-")
                    DatabaseUpdate(#DB, "INSERT INTO Tab_EPC_Members (EPC, Rufzeichen, Area, NewArea) VALUES('" + str3 + "','" + str4 + "','" + str5 + "','" + str1 + "')")
                  Until Eof(0)
                  DatabaseUpdate(#DB, "END")
                  DatabaseUpdate(#DB, "VACUUM")
                EndIf
              Else
                MessageRequester("Fehler", "Der Dateidownload ist fehlgeschlagen")
              EndIf
            Case 1010 To 1040                               ; Log nach Datum, Rufzeichen
              Define.s sSel = "SELECT * FROM Tab_AddGadgetColumn WHERE Kennz = 'Log' ORDER BY Col"
              sRecSce = AddColumns(sSel, #LI_Log)
              Select str1
                Case "letzte 100 QSO"
                  sRecSce  + " WHERE ROWID > " + GetGadgetText(#Txt_QSONr) + " - 101 ORDER BY ROWID DESC"
                Case "nach Datum"
                  sRecSce + " ORDER BY Datum DESC, UTC DESC"
                Case "nach Rufzeichen"
                  sRecSce + " ORDER BY Rufzeichen, Datum, UTC"
                Case "DL0NRU"
                  sRecSce + " WHERE DL0NRU ORDER BY Datum, UTC"
              EndSelect
              iRes = FillListIcon(sRecSce, #LI_Log)
              SetWindowTitle(1, "Log " + str1 + " (" + Str(iRes) + " Einträge)")
              HideWindow(#Wnd_Op, 1) : HideWindow(#Wnd_Log, 0) : HideGadget(#LI_Log, 0)
            Case 1050, 1055                                      ; Log -> ADIF
              Select MenuNr
                Case 1050
                  DeleteFile("D:\Dokumente\TXT\MP_Log.ADIF")
                  OpenFile(0, "D:\Dokumente\TXT\MP_Log.ADIF")
                Case 1055
                  DeleteFile("E:\MP_Log.ADIF")
                  OpenFile(0, "E:\MP_Log.ADIF")
              EndSelect
              WriteStringN(0, "")
              WriteStringN(0, "<PROGRAMID:9>Log_DK1IO")
              WriteStringN(0, "<ADIF_VER:1>2")
              WriteStringN(0, "<OPERATOR:5>DK1IO")
              WriteStringN(0, "<MY_NAME:15>Reinhard Lipkow")
              WriteStringN(0, "<MY_STREET:17>Im Eichenbleek 24")
              WriteStringN(0, "<MY_CITY:8>Neustadt")
              WriteStringN(0, "<MY_POSTAL_CODE:5>31535")
              WriteStringN(0, "<EOH>")
              str2 = InputRequester("ETPA-Nr. eingeben", "", "")
              DatabaseQuery(#DB, "SELECT * FROM Tab_Log WHERE  EETPA = '" + str2 + "'")
              While NextDatabaseRow(#DB)
                sDat = GetDBString(#DB, "Datum")
                sDat = Left(sDat, 4) + Mid(sDat, 6, 2) + Right(sDat, 2)
                sTim = GetDBString(#DB, "UTC")
                sTim = RSet(Str(Val(sTim) + 1), 4, "0")
                str2 = "<QSO_DATE:8>" + sDat + "<TIME_ON:4>" + sTim
                str3 = GetDBString(#DB, "Rufzeichen")
                str2 + "<CALL:" +Str(Len(Str3)) + ">" + str3
                str3 = GetDBString(#DB, "EigRufz")
                str2 + "<APP_Log_DK1IO_EigRufz:1>" + str3
                str3 = GetDBString(#DB, "Band")
                str2 + "<BAND:" + Str(Len(str3) + 1) + ">" + str3 + "m"
                str3 = GetDBString(#DB, "Mode")
                str2 + "<MODE:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Power")
                str2 + "<TX_PWR:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "RSTs")
                str2 + "<RST_SENT:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "RSTr")
                str2 + "<RST_RCVD:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Name")
                str2 + "<NAME:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "QTH")
                str2 + "<QTH:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Loc")
                str2 + "<GRIDSQUARE:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "ELoc")
                str2 + "<APP_Log_DK1IO_ELoc:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "IOTA")
                str2 + "<IOTA:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "EIOTA")
                str2 + "<APP_Log_DK1IO_EIOTA:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "SOTA")
                str2 + "<APP_Log_DK1IO_SOTA:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "ESOTA")
                str2 + "<APP_Log_DK1IO_ESOTA:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "EETPA")
                str2 + "<APP_Log_DK1IO_EETPA:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Px")
                str2 + "<APP_Log_DK1IO_Px:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "MP")
                str2 + "<APP_Log_DK1IO_MP:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Bemerkungen")
                str2 + "<APP_Log_DK1IO_Bemerkungen:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "Comment")
                str2 + "<COMMENT:" + Str(Len(str3)) + ">" + str3
                str3 = GetDBString(#DB, "DXCC")
                str2 + "<DXCC:" + Str(Len(str3)) + ">" + str3
                str2 + "<EOR>"
                WriteStringN(0, str2)
              Wend
              FinishDatabaseQuery(#DB)
              CloseFile(0)
              MessageRequester("OK", "Konvertierung erfolgreich")
            Case 1060                                                   ; Log -> CSV
              DeleteFile("D:\Dokumente\CSV\SOTA_Log.CSV")
              If OpenFile(0, "D:\Dokumente\CSV\SOTA_Log.CSV")
                str1 = InputRequester("Log -> CSV", "Datum eingeben", "")
                DatabaseQuery(#DB, "SELECT * FROM Tab_Log WHERE Datum = '" + str1 + "'")
                Debug DatabaseError()
                While NextDatabaseRow(#DB)
                  str2 = GetDBString(#DB, "Px")
                  If str2
                    str3 = str2 +"/"
                  Else
                    str3 = ""
                  EndIf
                  str3 + "DK1IO/P,"
                  str3 + Right(str1, 2) + "/" + Mid(str1, 6, 2) + "/" + Mid(str1, 3, 2) + ","
                  str3 + GetDBString(#DB, "UTC") + ","
                  str3 + GetDBString(#DB, "ESOTA") + ","
                  str2 = GetDBString(#DB, "Band")
                  Select str2
                    Case "40"
                      str3 + "7.0"
                    Case "30"
                      str3 + "10.1"
                    Case "20"
                      str3 + "14.0"
                  EndSelect 
                  str3 + ","
                  str2 = GetDBString(#DB, "Mode")
                  If Mid(str2, 2, 3) = "PSK"
                    str3 + "DATA,"
                  Else
                    str3 + str2 + ","
                  EndIf
                  str3 + GetDBString(#DB, "Rufzeichen")
                  WriteStringN(0, str3)
                Wend
                FinishDatabaseQuery(#DB)
                CloseFile(0)
                MessageRequester("OK", "Konvertierung erfolgreich")
              Else
                MessageRequester("Fehler", "Die Datei konnte nicht geöffnet werden!")
              EndIf
            Case 1070
              ;DatabaseUpdate(#DB, "ATTACH [\\RL-PC\C\Users\RL\Documents\DB3\Log DK1IO.db3] AS A")
              ;DatabaseUpdate(#DB, "CREATE TABLE Tab_Log1 AS SELECT * FROM A.Tab_Log")
              ;DatabaseUpdate(#DB, "DROP TABLE Tab_Log")
              ;DatabaseUpdate(#DB, "ALTER TABLE Tab_Log1 RENAME TO Tab_Log")
              ;DatabaseUpdate(#DB, "DETACH A")
              ;DatabaseUpdate(#DB, "VACUUM")
              If DatabaseError() = ""
                MessageRequester("OK", "Die Logtabellenübernahme war erfolgreich")
              EndIf
              ;FinishDatabaseQuery(#DB)
            Case 1080
              If bPapLogEing = #False
                SetMenuItemText(0, 1080, "Ende Papierlogeingabe")
                SetGadgetText(#Txt_Name, "UTC")
                HideGadget(#Str_UTC, 0) : DisableGadget(#Str_Name, 1)
                bPapLogEing = #True
                SetGadgetData(#Str_RSTr, #Str_UTC)
              Else
                SetMenuItemText(0, 1080, "Papierlog eingeben")
                SetGadgetText(#Txt_Name, "Name")
                HideGadget(#Str_UTC, 1) : DisableGadget(#Str_Name, 0)
                bPapLogEing = #False
                SetGadgetData(#Str_RSTr, #Str_Name)
              EndIf
            Case 2006 To 2160          ; Band
              SetGadgetData(#Txt_Band, Val(GetMenuItemText(0, MenuNr)))
              SetFreq() : Reset()
            Case 3410 To 3470                               ; PSK-Modes
              Select MenuNr
                Case 3410
                  iPSKMode = 0
                Case 3420
                  iPSKMode = 1
                Case 3440
                  iPSKMode = 8
                Case 3450
                  iPSKMode = 9
                Case 3460
                  iPSKMode = 16
                Case 3470
                  iPSKMode = 17
              EndSelect
              SetGadgetText(#Txt_Mode, str1)
              PSKCore_SetRXPSKMode(iPSKMode, 0)
            Case 3500
              str1 = InputRequester("Locator", "Länge/Breite eingeben", "")
              Define.d dLat, dLat1, dLong, dLong1, dbl1
              Define.s sL, sLat, sLong, sEW, sNS
              int1 = FindString(str1, "/")
              sLong = Left(str1, int1 - 1)
              dLong = ValD(Left(sLong, Len(sLong) - 1))
              sLat = Right(str1, Len(str1) - int1)
              dLat = ValD(Left(sLat, Len(sLat) - 1))
              sEW = Right(sLong, 1)
              Select sEW
                Case "E"
                  dLong1 = dLong + 180
                Case "W"
                  dLong1 = 180 - dLong 
              EndSelect
              int1 = Int(dLong1) / 20
              sL = Chr(Asc("A") + int1)
              sNS = Right(sLat, 1)
              Select sNS
                Case "N"
                  dLat1 = dLat + 90
                Case "S"
                  dLat1 = 90 - dLat
              EndSelect
              int1 = Int(dLat1) / 10
              sL + Chr(Asc("A") + int1)
              int1 = (Int(dLong) % 20) / 2
              sl + Chr(Asc("0") + int1)
              int1 = Int(dLat) % 10
              sL + Chr(Asc("0") + int1)
              dbl1 = dLong - Int(dLong)
              int1 = Int(dLong) % 20
              If int1 & 1 : dbl1 + 1 : EndIf
              int1 = dbl1 * 60
              sL + Chr(Asc("A") + int1 / 5)
              dbl1 = dLat - Int(dLat)
              int1 = dbl1 * 60
              sL + Chr(Asc("A") + int1 * 2 / 5)
              SetGadgetText(#Str_Locator, sL)
            Case 3600
              Select Mid(GetGadgetText(#Txt_Mode), 2, 1)
                Case "C"
                  
                Case "P"
                  
              EndSelect
            Case 4010
              SetGadgetText(#Btn_Begr, "COTA")
              SetGadgetText(#Btn_Bye, "CO Bye")
              SetGadgetText(#Btn_TnxInfo, "Ref")
            Case 4020
              SetGadgetText(#Btn_Begr, "ETPA")
              SetGadgetText(#Btn_Bye, "ET Bye")
              SetGadgetText(#Btn_TnxInfo, "Ref")
            Case 4030
              SetGadgetText(#Btn_Begr, "SOTA")
              SetGadgetText(#Btn_Bye, "SO Bye")
              SetGadgetText(#Btn_TnxInfo, "Ref")
            Case 4040
              SetGadgetText(#Btn_Begr, "ETSO")
              SetGadgetText(#Btn_Bye, "ES Bye")
              SetGadgetText(#Btn_TnxInfo, "Ref")
            Case 4050
              SetGadgetText(#Btn_Begr, "Begr.")
              SetGadgetText(#Btn_Bye, "Bye")
              SetGadgetText(#Btn_TnxInfo, "Tnx Info")
            Case 4040
              Locatorberechnung()
            Case 5000
              SetGadgetText(#Btn_CQ, "CQ Test") : SetGadgetText(#Btn_Begr, "Nr")
              SetGadgetText(#Btn_TnxInfo, "QSL + Nr") : SetGadgetText(#Btn_TnxBye, "QSL")
              SetGadgetText(#Btn_Bye, "Nr?")
            Case 5010
              SetGadgetText(#Btn_CQ, "CQ") : SetGadgetText(#Btn_Begr, "Begr")
              SetGadgetText(#Btn_TnxInfo, "Tnx Info") : SetGadgetText(#Btn_TnxBye, "Tnx Bye")
              SetGadgetText(#Btn_Bye, "Bye")
            Case 5100
              HideGadget(#Txt_LfdNr, 0) : HideGadget(#Str_LfdNr, 0) : SetGadgetData(#Txt_LfdNr, #True)
              SetGadgetText(#Str_LfdNr, RSet(Str(GetGadgetData(#Str_LfdNr)), 3, "0"))
            Case 5110
              HideGadget(#Txt_LfdNr, 1) : HideGadget(#Str_LfdNr, 1) : SetGadgetData(#Txt_LfdNr, #False)
            Case 5120
              SetGadgetData(#Str_LfdNr, 1) : SetGadgetText(#Str_LfdNr, "001")
            Case 6000, 6010
              sEigRufz = GetMenuItemText(0, MenuNr) : EigRufz$ = sEigRufz
              If sMP : sEigRufz + "/" + sMP : EndIf
              DatabaseUpdate(#DB, "UPDATE Tab_Start SET EigRufz = '" + sEigRufz + "'")
              FinishDatabaseQuery(#DB)
              SetWindowTitle(#Wnd_Op, "Log DK1IO - QRV: " + sEigRufz)
            Case 6100 To 6120
              sMP = GetMenuItemText(0, MenuNr)
              DatabaseUpdate(#DB, "UPDATE Tab_Start SET MP = '" + sMP + "'")
              If sMP : sEigRufz = EigRufz$ + "/" + sMP : Else : sEigRufz = EigRufz$ :: EndIf
              SetWindowTitle(#Wnd_Op, "Log DK1IO - QRV: " + sEigRufz)
        EndSelect 
      EndSelect
    Case #Wnd_Log
      Select EventNr
        Case #PB_Event_CloseWindow
          ClearGadgetItems(#LI_Log)
          HideWindow(#Wnd_Log, 1) : HideWindow(#Wnd_Op, 0)
          SetGadgetData(#Cnt_Log, #Str_Rufzeichen)
        Case #PB_Event_Gadget
          Select GadgetNr
            Case #LI_Log
              Select TypeNr
                Case #PB_EventType_LeftClick
                  Define.Rect rTemp
                  str1 = GetGadgetItemText(#LI_Log, iRow, iCol)
                  str2 = GetGadgetItemText(#LI_Log, -1, iCol)
                  str3 = GetGadgetItemText(#LI_Log, iRow, 0)
                  Define.s str6
                  Select str2
                    Case "Neu", "QSLe", "QSLa", "DL0NRU", "QSLPrt"
                      If str1= "£" : str1 = "S" : str6 = "-1" : Else : str1 = "£" : str6 = "0" : EndIf
                      SetGadgetItemText(GadgetNr, iRow, str1, iCol)
                      sCmd = "UPDATE Tab_Log SET '" + str2 +  "' = " + str6 + " WHERE ROWID = " + str3
                      DatabaseUpdate(#DB, sCmd)
                    Default
                      SetGadgetText(#Str_Update1, str1)
                      rTemp\top = iCol : rTemp\left = #LVIR_BOUNDS
                      SendMessage_(GadgetID(#LI_Log), #LVM_FIRST + 56, iRow, @rTemp)
                      ResizeGadget(#Str_Update1, rTemp\left + 22, rTemp\Top + 17, rTemp\right - rTemp\left, rTemp\bottom - rTemp\top)
                      HideGadget(#Str_Update1, 0) : SetActiveGadget(#Str_Update1)
                  EndSelect
                Case #PB_EventType_RightClick
                  HideGadget(#Str_Update1, 1)
                  str1 = GetGadgetItemText(#LI_Log, iRow, 0)
                  If str1 = Str(Val(GetGadgetText(#Txt_QSONr)) - 1)
                    If MessageRequester("Log DK1IO", "Soll der markierte Datensatz wirklich gelöscht werden?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
                      sCmd = "DELETE FROM Tab_Log WHERE ROWID = " + str1
                      DatabaseUpdate(#DB, sCmd)
                      RemoveGadgetItem(#LI_Log, iRow)
                      SetGadgetText(#Txt_QSONr, Str(Val(GetGadgetText(#Txt_QSONr)) - 1))
                    Else
                      For i = 1 To iCols
                        SetGadgetItemColor(#LI_Log, iRow, #PB_Gadget_FrontColor, #DBlue, i)
                        SetGadgetItemColor(#LI_Log, iRow, #PB_Gadget_BackColor, #LogCol, i)
                      Next
                    EndIf
                  Else
                    MessageRequester("Log DK1IO", "Nur der letzte Datensatz kann gelöscht werden !")
                    For i = 1 To iCols
                      SetGadgetItemColor(#LI_Log, iRow, #PB_Gadget_FrontColor, #DBlue, i)
                      SetGadgetItemColor(#LI_Log, iRow, #PB_Gadget_BackColor, #LogCol, i)
                    Next
                  EndIf
              EndSelect
            Case #Str_Update1
              Select TypeNr
                Case #PB_EventType_Change
                  SetGadgetData(#Str_Update1, #True)
                Case #PB_EventType_LostFocus
                  If GetGadgetData(#Str_Update1)
                    str1 = GetGadgetText(#Str_Update1)
                    str2 = GetGadgetItemText(#LI_Log, iRow, 0)
                    sCmd = "UPDATE Tab_Log SET '" + GetGadgetItemText(#LI_Log, -1, iCol) +  "' = '" + str1 + "' WHERE ROWID = " + str2
                    DatabaseUpdate(#DB, sCmd)
                    SetGadgetItemText(#LI_Log, iRow, str1, iCol)
                    SetGadgetData(#Str_Update1, #False) : HideGadget(#Str_Update1, 1)
                    sTab = ""
                  EndIf
              EndSelect
          EndSelect
      EndSelect
  EndSelect
ForEver


; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 228
; FirstLine = 210
; EnableXP
; UseIcon = PBIcn.ico
; Executable = Log DK1IO.exe
; CPU = 2
; IncludeVersionInfo
; VersionField0 = 3.6.1.0
; VersionField2 = Reinhard Lipkow
; VersionField3 = Log DK1IO
; VersionField6 = Logprogramm mit  PSK
; VersionField8 = Log DK1IO
; VersionField13 = dk1io@arcor.de
; EnableUnicode