﻿; Programmteile für PSK-Betrieb
; DK1IO 08/07

If OpenLibrary(#Lib_PSKCore, "C:\Users\RL\Documents\DLL\PSKCore.dll")
  Prototype AbortTX()
  Prototype ClearTXBuffer()
  Prototype EnableRXChannel(channel, enable)
  Prototype GetFFTData(DataArray, fstart, fend)
  Prototype GetRXFrequency(channel)
  Prototype GetTXCharsRemaining()
  Prototype GetVectorData(VectorArray, channel)
  Prototype SetAFCLimit(limit, channel)
  Prototype SetFFTMode(ave, maxscale, mode)
  Prototype SetRXFrequency(freq, range, channel)
  Prototype SetRXPSKMode(mode, channel)
  Prototype SetSquelchThreshold(thresh, mode, channel)
  Prototype SetTXFrequency(freq)
  Prototype SendTXCharacter(txchar, cntrl)
  Prototype SendTXString(TXStrg.s)
  Prototype StartSoundCard(hWnd, cardnum, numRXchannels)
  Prototype StartRXTXSoundCard(hWnd, RXcardnum, TXcardnum, numRXchannels)
  Prototype StartTX(mode)
  Prototype StopSoundCard()
  Prototype StopTX()

  Global PSKCore_AbortTX.AbortTX                         = GetFunction(#Lib_PSKCore, "fnAbortTX")
  Global PSKCore_ClearTXBuffer.ClearTXBuffer             = GetFunction(#Lib_PSKCore, "fnClearTXBuffer")
  Global PSKCore_EnableRXChannel.EnableRXChannel         = GetFunction(#Lib_PSKCore, "fnEnableRXChannel")
  Global PSKCore_GetFFTData.GetFFTData                   = GetFunction(#Lib_PSKCore, "fnGetFFTData")
  Global PSKCore_GetRXFrequency.GetRXFrequency           = GetFunction(#Lib_PSKCore, "fnGetRXFrequency")
  Global PSKCore_GetTXCharsRemaining.GetTXCharsRemaining = GetFunction(#Lib_PSKCore, "fnGetTXCharsRemaining")
  Global PSKCore_GetVectorData.GetVectorData             = GetFunction(#Lib_PSKCore, "fnGetVectorData")
  Global PSKCore_SendTXCharacter.SendTXCharacter         = GetFunction(#Lib_PSKCore, "fnSendTXCharacter")
  Global PSKCore_SendTXString.SendTXString               = GetFunction(#Lib_PSKCore, "fnSendTXString")
  Global PSKCore_SetAFCLimit.SetAFCLimit                 = GetFunction(#Lib_PSKCore, "fnSetAFCLimit")
  Global PSKCore_SetFFTMode.SetFFTMode                   = GetFunction(#Lib_PSKCore, "fnSetFFTMode")
  Global PSKCore_SetRXFrequency.SetRXFrequency           = GetFunction(#Lib_PSKCore, "fnSetRXFrequency")
  Global PSKCore_SetRXPSKMode.SetRXPSKMode               = GetFunction(#Lib_PSKCore, "fnSetRXPSKMode")
  Global PSKCore_SetSquelchThreshold.SetSquelchThreshold = GetFunction(#Lib_PSKCore, "fnSetSquelchThreshold")
  Global PSKCore_SetTXFrequency.SetTXFrequency           = GetFunction(#Lib_PSKCore, "fnSetTXFrequency")
  Global PSKCore_StartSoundCard.StartSoundCard           = GetFunction(#Lib_PSKCore, "fnStartSoundCard")
  Global PSKCore_StartRXTXSoundCard.StartRXTXSoundCard   = GetFunction(#Lib_PSKCore, "fnStartRXTXSoundCard")
  Global PSKCore_StartTx.StartTx                         = GetFunction(#Lib_PSKCore, "fnStartTX")
  Global PSKCore_StopSoundCard.StopSoundCard             = GetFunction(#Lib_PSKCore, "fnStopSoundCard")
  Global PSKCore_StopTX.StopTX                           = GetFunction(#Lib_PSKCore, "fnStopTX")
Else
  MessageRequester("Fehler", "Die Datei 'PSKCore.dll' konnte nicht geöffnet werden !")
EndIf

Macro GetDBLong(db, Col)
  GetDatabaseLong(db, DatabaseColumnIndex(db, Col))
EndMacro

Macro GetDBString(db, Col)
  GetDatabaseString(db, DatabaseColumnIndex(db, Col))
EndMacro

Procedure PrintFreq()
  Dim fFreq.f(9)
  Define i, int1, str1.s
  StartDrawing(WindowOutput(#Wnd_Op))
    DrawingFont(Font3)
    Box(10, 545, 512, 30, #CntCol)
    Box(10, 665, 512, 19, # CntCol)
    LineXY(10, 575, 522, 575, #Black)
    For i = 1 To 7
      int1 = 10 + i * 64
      LineXY(int1, 563, int1, 574, #DBlue)
      fFreq(i) = (Val(sFreq) - 1000)/1000 + 0.25 + i * 0.25
      str1 = StrF(fFreq(i), 2)
      DrawText(int1 - Len(str1) * 2.5, 548, str1, #DBlue, #CntCol)
    Next
    DrawingMode(#PB_2DDrawing_Transparent)
    DrawingFont(Font0)
    DrawText(iLineRX + 1, 557, Chr($71), #DGreen)
    DrawText(iLineRX + 1, 661, Chr($70), #DGreen)
  StopDrawing()
EndProcedure

Procedure.b SingleAlpha(VerglStr.s)
  Select Asc(VerglStr)
    Case Asc("A") To Asc("Z"), Asc("a") To Asc("z"), Asc("Ä"), Asc("Ö"), Asc("Ü"), Asc("ä"), Asc("ö"), Asc("ü"), Asc("/"), Asc("-"), $B9 To $FE
      ProcedureReturn #True
    Default
      ProcedureReturn #False
  EndSelect
EndProcedure

Procedure.b MultiAlpha(VerglStr.s)
  Define.b bVergl = #True : Define i
  For i = 1 To Len(VerglStr)
    bVergl & SingleAlpha(Mid(VerglStr, i, 1))
  Next
  ProcedureReturn bVergl
EndProcedure

Procedure.b SingleAlphaNumeric(VerglStr.s)
  Select Asc(VerglStr)
    Case Asc("A") To Asc("Z"), Asc("a") To Asc("z"), Asc("Ä"), Asc("Ö"), Asc("Ü"), Asc("ä"), Asc("ö"), Asc("ü"), Asc("0") To Asc("9"), Asc("/"), Asc("-"), 192 To 255
      ProcedureReturn #True
    Default
      ProcedureReturn #False
  EndSelect
EndProcedure

Procedure.b MultiAlphaNumeric(VerglStr.s)
  Define.b bVergl = #True : Define i
  For i = 1 To Len(VerglStr)
    bVergl & SingleAlphaNumeric(Mid(VerglStr, i, 1))
  Next
  ProcedureReturn bVergl
EndProcedure

Procedure.b SingleNumeric(VerglStr.s)
  Select Asc(VerglStr)
    Case Asc("0") To Asc("9")
      ProcedureReturn #True
    Default
      ProcedureReturn #False
  EndSelect
EndProcedure

Procedure.b MultiNumeric(VerglStr.s)
  Define.b bVergl = #True : Define i
  For i = 1 To Len(VerglStr)
    bVergl & SingleNumeric(Mid(VerglStr, i, 1))
  Next
  ProcedureReturn bVergl
EndProcedure

Procedure.b Like(VerglStr.s, PH.s, bPHL.b)
  Define.b bVergl = #True : Define i
  If bPHL
    If Len(PH) <> Len(VerglStr) : ProcedureReturn #False : EndIf
    For i = 1 To Len(PH)
      Select Mid(PH, i, 1)
        Case "#"
          bVergl & SingleNumeric(Mid(VerglStr, i, 1))
        Case "@"
          bVergl & SingleAlpha(Mid(VerglStr, i, 1))
        Case "*"
          bVergl & SingleAlphaNumeric(Mid(VerglStr, i, 1))
        Case "-"
          bVergl & #True
      EndSelect
    Next
  Else
    For i = 1 To Len(PH)
      Select Mid(PH, i, 1)
        Case "#"
          bVergl & SingleNumeric(VerglStr)
        Case "+"
          bVergl & MultiNumeric(VerglStr)
        Case "@"
          bVergl & SingleAlpha(VerglStr)
        Case "$"
          bVergl & MultiAlpha(VerglStr)
        Case "*"
          bVergl & SingleAlphaNumeric(VerglStr)
        Case "%"
          bVergl & MultiAlphaNumeric(VerglStr)
        Case "§"
          Define bVergl1.b, ii
          bVergl = #False
          For ii = 1 To Len(VerglStr)
            bVergl | SingleNumeric(Mid(VerglStr, ii, 1))
            bVergl1 | SingleAlpha(Mid(VerglStr, ii, 1))
          Next
          bVergl & bVergl1
      EndSelect
    Next
  EndIf
  ProcedureReturn bVergl
EndProcedure

Procedure StopTX(iBtn)
  PSKCore_SendTXString("   ")
  PSKCore_AbortTX()
  HideGadget(#Edt_PSKTXTxt, 1) : HideGadget(#Edt_PSKRXTxt, 0)
  WriteSerialPortString(#COM_FT991, "TX0;")
  SetGadgetText(#Edt_PSKTXTxt, "")
  SetGadgetColor(iBtn, #PB_Gadget_BackColor, #BtnCol)
  range\cpMin = SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_GETTEXTLENGTHEX, @gtle, 0)
  range\cpMax = range\cpMin + 1
  SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_EXSETSEL, 0, @range)
  Define.s str1 = #CR$
  SendMessage_(GadgetID(#Edt_PSKRXTxt), #EM_REPLACESEL, 0, @str1)
  bTXStop = #False : bPSKTX = #False
  SetActiveGadget(GetGadgetData(#Cnt_Log))
EndProcedure

Procedure SpTxtAusgPSK(GadgetNr, sLang.s)
  HideGadget(#Edt_PSKRXTxt, 1) : HideGadget(#Edt_PSKTXTxt, 0)
  Define sRecSce.s, str1.s, str2.s, sDay.s, sDat.s, sHour.s
  sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = '" + GetGadgetText(GadgetNr) + sLang + "'"
  iBtnNr = GadgetNr
  str2 = GetGadgetText(#Btn_Begr)
  Select GadgetNr
    Case #Btn_Begr
      Select str2
        Case "COTA", "ETPA", "SOTA", "ETSO"
          sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'Begr " + str2 + "'"
      EndSelect
    Case #Btn_Bye
      Select str2
        Case "COTA", "ETPA", "SOTA", "ETSO"
          sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'Bye ES'"
        Case "Begr."
          sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'Bye" + sLang + "'"
      EndSelect
    Case #Btn_CQ
      Select str2
        Case "COTA", "ETPA", "SOTA", "ETSO"
          sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'CQ ETPA'"
        Case "Begr."
          sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'CQ'"
      EndSelect
    Case #Btn_Fin
      sLang = "A"
    Case #Btn_Rig
      If GetGadgetData(#Txt_Band) = 2
        sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'Rig 2m" + sLang + "'"
      EndIf
    Case #Btn_TnxInfo
      If str2 = "ETSO"
        sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'Ref'"
      EndIf
    Case #Btn_Vorst
      If sEigRufz = "DL0NRU"
        sRecSce = "SELECT * FROM Tab_SpTxtPSK WHERE Bez = 'DL0NRU" + sLang + "'"
      Else
        If iNumQSOB4
          If sLang = " E"
            str1 = "Number of QSO: " + Str(iNumQSOB4) + #CR$
            str1 + "Last QSO: " + Right(sDatLastQSOB4, 2) + " " + sMonth(Val(Mid(sDatLastQSOB4, 6, 2))) + " " + Left(sDatLastQSOB4, 4)
            str1 + " on " + sBandLastQSOB4 + "m in " + sModeLastQSOB4 + #CR$
          Else
            str1 = "Anzahl der QSO: " + Str(iNumQSOB4) + #CR$
            str1 + "Letztes QSO: " + Right(sDatLastQSOB4, 2) + " " + sMonth(Val(Mid(sDatLastQSOB4, 6, 2))) + " " + Left(sDatLastQSOB4, 4)
            str1 + " auf " + sBandLastQSOB4 + "m in " + sModeLastQSOB4 + #CR$
          EndIf
        EndIf
      EndIf
  EndSelect
  DatabaseQuery(#DB, sRecSce)
  FirstDatabaseRow(#DB)
  bTXAus = GetDBLong(#DB, "AutoTXAus")
  str1 + GetDBString(#DB, "Speichertext")
  str1 = #CR$ + SuchenText(str1, sLang) + " "
  Select GadgetNr
    Case #Btn_Begr
      If GetGadgetText(#Str_RSTs) = ""
        SetGadgetText(#Str_RSTs, "579")
      EndIf
    Case #Btn_CQ To #Btn_de2, #Btn_QRZ, #Btn_Fin
      ;sPSKRXData = ""
      Select GadgetNr
        Case #Btn_de, #Btn_de2
          str1 + #CR$
      EndSelect
    Case #Btn_Rig
      Select sLang
        Case " E"
          str2 = GetGadgetText(#Str_WXE)
          If str2 And str2 <> "WX E"
            str1 + #CR$ + "WX:       " + str2 + ", Temp " + GetGadgetText(#Str_Temp) + "°"
          EndIf
        Default
          str2 = GetGadgetText(#Str_WXD)
          If str2 And str2 <> "WX D"
            str1 + #CR$ + "WX:       " + str2 + ", Temp " + GetGadgetText(#Str_Temp) + "°"
          EndIf
      EndSelect
  EndSelect
  str1 + Chr(4)
  Define.s{1000} sPSKTXTxt
  PokeS(@sPSKTXTxt, str1, -1, #PB_Ascii)
  bPSKTX = #True
  SetGadgetText(#Edt_PSKTXTxt, str1)
  SetGadgetColor(GadgetNr, #PB_Gadget_BackColor, #Red)
  WriteSerialPortString(#COM_FT991, "TX1;")
  PSKCore_StartTX(iPSKMode)
  PSKCore_SendTXString(sPSKTXTxt)
  Define iCharsRemng = PSKCore_GetTXCharsRemaining()
  While iCharsRemng
    Select WindowEvent()
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #Btn_PwrDn
            SetPower(-1)
          Case #Btn_PwrUp
            SetPower(1)
          Case #Btn_RX
            bTXAus = #True
            Break
        EndSelect
      Case #PB_Event_Timer
        GetSystemTime_(yST)
        SetGadgetText(#Txt_Zeit, RSet(Str(yST\wHour), 2, "0") + ":" + RSet(Str(yST\wMinute), 2, "0") + ":" + RSet(Str(yST\wSecond), 2, "0"))
    EndSelect
    Delay(1)
    If Len(str1) > PSKCore_GetTXCharsRemaining()
      str1 = Right(str1, Len(str1) - 1)
      SetGadgetText(#Edt_PSKTXTxt, str1)
      iCharsRemng = Len(str1)
    EndIf
  Wend
  If bTXAus
    StopTX(GadgetNr)
  Else
    SetGadgetColor(GadgetNr, #PB_Gadget_BackColor, #BtnCol)
    PB_Gadget_SendGadgetCommand(GadgetID(#Btn_TX), #PB_Event_LeftClick)
  EndIf
EndProcedure

Procedure SetPSK()
  CreateImage(0, 512, 90, 24)
  StartDrawing(ImageOutput(0))
    *ImgBuf = DrawingBuffer()
    iImgLinLen = DrawingBufferPitch()
  StopDrawing()
  *ImgMemMovSrce = *ImgBuf + iImgLinLen
  *ImgMemMovDest = *ImgBuf
  iImgMemMovSize = iImgLinLen * 89
  *ImgNewLin = *ImgBuf + iImgMemMovSize
  PSKCore_StopSoundCard()
  PSKCore_EnableRXChannel(0, #True)
  Define int1 = PSKCore_StartRXTXSoundCard(hWnd, -1, -1, 1)
  If int1
    MessageRequester("","Soundkartenfehler " + Str(int1))
  EndIf
  PSKCore_SetRXFrequency(iRXFreq, 0, 0)
  PSKCore_SetTXFrequency(1500)
  PSKCore_SetRXPSKMode(0, 0)
  PSKCore_SetFFTMode(1, 1000, 1)
  PSKCore_SetSquelchThreshold( 15, 0, 0)
  PSKCore_SetAFCLimit(50, 0)
  SetGadgetData(#Btn_FreqDn, #True)
  Old_PSK_Proc          = SetWindowLong_(hWnd, #GWL_WNDPROC, @New_PSK_Proc())
  Old_Edt_PSKRXTxt_Proc = SetWindowLong_(GadgetID(#Edt_PSKRXTxt), #GWL_WNDPROC, @New_Edt_PSKRXTxt_Proc())
  Old_Edt_PSKTXTxt_Proc = SetWindowLong_(GadgetID(#Edt_PSKTXTxt), #GWL_WNDPROC, @New_Edt_PSKTXTxt_Proc())
EndProcedure


; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 75
; FirstLine = 49
; Folding = ---
; UseIcon = PBIcn.ico
; CPU = 1
; EnableUnicode